Use the mappings in the tables to map an
[`UploadCallConversionsRequest`](https://developers.google.com/google-ads/api/reference/rpc/latest/UploadCallConversionsRequest) in the Google Ads API to its
[`IngestEventsRequest`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#ingesteventsrequest) equivalent in the Data Manager API.

## Authentication


The Data Manager API requires credentials with a different scope than the
Google Ads API. Follow the steps in
[Set up API access](https://developers.google.com/data-manager/api/devguides/quickstart/set-up-access.md.txt) to generate new
credentials that include the Data Manager API scope.

## Request fields

| [`UploadCallConversionsRequest`](https://developers.google.com/google-ads/api/reference/rpc/latest/UploadCallConversionsRequest) (Google Ads API) | [`IngestEventsRequest`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#ingesteventsrequest) (Data Manager API) | Notes |
|---|---|---|
| - `customer_id` - `login-customer-id` request header - `linked-customer-id` request header - `conversion_action` | `destinations` | See [Customer and conversion action fields](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/upgrade/field-mappings.md.txt#customer-conversion). |
| No equivalent | `consent` | Optional. Default consent settings for all events in the request. Unlike the Google Ads API, which only supports setting consent on individual conversions, the Data Manager API lets you set consent once for the entire request. To override the default for an individual event, set the `consent` field of the `Event`. |
| No equivalent | `encoding` | **Required:** Set to the [`Encoding`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#encoding) (`HEX` or `BASE64`) used for `UserIdentifier` values. |
| `partial_failure` | No equivalent | The Data Manager API [uses a fast-fail error model](https://developers.google.com/data-manager/api/devguides/concepts/understand-errors.md.txt#fast-fail). If any field of an `IngestEventsRequest` fails validation, the Data Manager API rejects the entire request. If the request succeeds, use [diagnostics](https://developers.google.com/data-manager/api/devguides/diagnostics.md.txt) to retrieve errors and warnings for individual events. |
| `validate_only` | `validate_only` |   |
| `conversions` | `events` | The list of conversions or events. See [Conversion fields](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/upgrade/field-mappings.md.txt#conversion) for details. |

> [!NOTE]
> **Note:** [Encryption](https://developers.google.com/data-manager/api/devguides/concepts/encryption.md.txt) isn't supported for call conversions. Don't set the `encryption_info` field on the request.

## Customer and conversion action fields

In the Google Ads API, you set the `login-customer-id` and `linked-customer-id`
[request headers](https://developers.google.com/google-ads/api/docs/concepts/call-structure.md.txt#request-headers) for different authentication scenarios.

In the Data Manager API, you specify login and linked customer information using
fields of a `Destination` instead of request headers. Check out
[Configure destinations](https://developers.google.com/data-manager/api/devguides/concepts/destinations.md.txt) for more information about
destinations.

Here's how to map the Google Ads API fields for a single `conversion_action`
to the equivalent fields in a `Destination`:

| Google Ads API | [`Destination`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#destination) (Data Manager API) | Notes |
|---|---|---|
| `customer_id` of the request | `operating_account` | Set the `account_id` to the customer ID of the [Google Ads conversion account](https://developers.google.com/google-ads/api/docs/conversions/getting-started.md.txt#conversion_tracking_setup). Set the `account_type` of the `operating_account` to `GOOGLE_ADS`. |
| `developer-token` request header | No equivalent | The Data Manager API doesn't use developer tokens. The Google Ads API also [no longer requires](https://developers.google.com/google-ads/api/docs/api-policy/developer-token.md.txt) them. |
| `login-customer-id` request header | `login_account` | Set the `account_id` to the customer ID of the login account. Set `account_type` to `GOOGLE_ADS` if the login account is a Google Ads account, or `DATA_PARTNER` if the login account is a data partner account. |
| `linked-customer-id` request header | `linked_account` | Only applies if you're a data partner sending data through a [partner link](https://developers.google.com/data-manager/api/devguides/accounts/partner-links.md.txt). If the partner link is with a parent manager account of the `operating_account`, set the `account_id` to the customer ID of the Google Ads account that has the partner link and set `account_type` to `GOOGLE_ADS`. If the partner link is directly with the `operating_account`, don't set the `linked_account` field. See [Data partner scenarios](https://developers.google.com/data-manager/api/devguides/concepts/destinations.md.txt#ads-data-partner). |
| `conversion_action` of a `CallConversion` | `product_destination_id` | Set to the numeric ID of the `UPLOAD_CALLS` conversion action. Don't use the resource name of the `ConversionAction`. |
| No equivalent | `reference` | A user-defined identifier for the `Destination`. Set this field if you're [sending events to multiple destinations](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/send-events.md.txt#multiple-destinations). |

## Conversion fields

> [!IMPORTANT]
> **Important:** In the Google Ads API, you pass the caller's phone number as an unhashed string in the `caller_id` field of a `CallConversion`. In the Data Manager API, you must format the phone number in [E.164 format](https://developers.google.com/data-manager/api/devguides/concepts/formatting.md.txt#userdata_format), hash it using SHA-256, encode the hash using hex or Base64 encoding, and set the `phone_number` field of a [`UserIdentifier`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#useridentifier) in `user_data.user_identifiers`.

| [`CallConversion`](https://developers.google.com/google-ads/api/reference/rpc/latest/CallConversion) (Google Ads API) | [`Event`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#event) (Data Manager API) | Notes |
|---|---|---|
| `caller_id` | `user_data.user_identifiers[].phone_number` | **Required.** Format the phone number in [E.164 format](https://developers.google.com/data-manager/api/devguides/concepts/formatting.md.txt#userdata_format), hash it using SHA-256, encode the hash using hex or Base64 encoding, and set the `phone_number` field of a [`UserIdentifier`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#useridentifier) in the [`UserData`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#userdata) object. Also set `encoding` on the [`IngestEventsRequest`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#ingesteventsrequest). |
| `call_start_date_time` | `call_info.start_timestamp` | **Required.** Set `start_timestamp` on the [`CallInfo`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#callinfo) object. - If using the JSON format, set to a value in [RFC 3339](https://www.ietf.org/rfc/rfc3339) format, which differs slightly from the [Google Ads API date and time format](https://developers.google.com/google-ads/api/docs/conversions/upload-calls.md.txt#requirements). - If using protocol buffers, use a [`Timestamp`](https://protobuf.dev/reference/protobuf/google.protobuf/#timestamp) and set the `seconds` and (optionally) the `nanoseconds` fields. <br /> See [Timestamp format](https://developers.google.com/data-manager/api/devguides/concepts/formatting.md.txt#timestamp_format) for details. |
| `consent` | `consent` | Both APIs use a similar [`Consent`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#consent) object (`ad_user_data`, `ad_personalization`). For the Data Manager API, you can also set consent for all events in a request by setting the request-level `consent` field. |
| `conversion_action` | `destination_references` | Set `product_destination_id` on the [destination](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/upgrade/field-mappings.md.txt#customer-conversion). If [sending events to multiple destinations](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/send-events.md.txt#multiple-destinations), set `destination_references` to the corresponding `reference` of the destination. |
| `conversion_date_time` | `event_timestamp` | **Required.** Must not be earlier than `call_info.start_timestamp`. - If using the JSON format, set to a value in [RFC 3339](https://www.ietf.org/rfc/rfc3339) format, which differs slightly from the [Google Ads API date and time format](https://developers.google.com/google-ads/api/docs/conversions/upload-calls.md.txt#requirements). - If using protocol buffers, use a [`Timestamp`](https://protobuf.dev/reference/protobuf/google.protobuf/#timestamp) and set the `seconds` and (optionally) the `nanoseconds` fields. <br /> See [Timestamp format](https://developers.google.com/data-manager/api/devguides/concepts/formatting.md.txt#timestamp_format) for details. |
| `conversion_value` | `conversion_value` |   |
| `currency_code` | `currency` |   |
| `custom_variables` | `custom_variables` | See [Custom variable fields](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/upgrade/field-mappings.md.txt#custom-variables) for details. |
| No equivalent | `event_source` | Optional. Set to a valid [`EventSource`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#eventsource) enum value. |

## Custom variable fields

| [`CustomVariable`](https://developers.google.com/google-ads/api/reference/rpc/latest/CustomVariable) (Google Ads API) | [`CustomVariable`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#customvariable) (Data Manager API) | Notes |
|---|---|---|
| No equivalent | `destination_references` | If [sending events to multiple destinations](https://developers.google.com/data-manager/api/devguides/events/google-ads/call/send-events.md.txt#multiple-destinations), use this field to indicate which destinations should receive a specific custom variable. |
| `conversion_custom_variable` | `variable` | Set to the name of the variable instead of a resource name. |
| `value` | `value` |   |

## Response fields

| [`UploadCallConversionsResponse`](https://developers.google.com/google-ads/api/reference/rpc/latest/UploadCallConversionsResponse) (Google Ads API) | [`IngestEventsResponse`](https://developers.google.com/data-manager/api/reference/rpc/google.ads.datamanager.v1.md.txt#ingesteventsresponse) (Data Manager API) | Notes |
|---|---|---|
| `partial_failure_error` | No equivalent | The Data Manager API [uses a fast-fail error model](https://developers.google.com/data-manager/api/devguides/concepts/understand-errors.md.txt#fast-fail). If any field of an `IngestEventsRequest` fails validation, the Data Manager API rejects the entire request. |
| `request-id` [response header](https://developers.google.com/google-ads/api/docs/concepts/call-structure.md.txt#request-id) | `request_id` | The request ID is returned as a response field in the Data Manager API instead of as a response header. |
| `results` | No equivalent | The Data Manager API processes events asynchronously. Check the processing results using [diagnostics](https://developers.google.com/data-manager/api/devguides/diagnostics.md.txt). |